Subject: bug#52523: 29.0.50; defcustom :type 'key-sequence not following key-valid-p format

From: Stefan Kangas <[email-masked]>
Date: Mon, 27 Dec 2021 07:41:34 -0800

Lars Ingebrigtsen <[email-masked]> writes:

>> However, if we do that the problem is that we then risk having two
>> definitions of "key sequence": both the old and the new style.
>>
>> See also (info "(elisp) Key Sequences"), that uses the old style.
>
> Yes, that's confusing.  I meant to have the `key-valid-p' say what it
> accepts as a valid key binding, and then the other functions refer to it.

Do you mean here "a valid key"?  A key binding AFAIU is a mapping from
"KEY => DEFINITION" as described in `keymap-set-after', and belongs in a
key map.

>> `keymap-set' says:
>>
>>     Set key sequence KEY to DEFINITION in KEYMAP.
>>
>> So here is again the "new" style used as the definition of a key
>> sequence, which seems to contradict the Elisp manual.
>
> Yes.  Please go ahead and fix up the doc strings.  😀

I tried to do that on master (commit 8df3a71c52), please take a look.
I also filed a number of documentation bugs separately while looking
over the  info manual.